/* stack.c generated by valac 0.56.17, the Vala compiler
 * generated from stack.vala, do not modify */

/*   FILE: stack.vala -- A stack
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 04 December 2013 
 *
 * Copyright (c) 2013 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_STACK (stack_get_type ())
#define STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STACK, Stack))
#define STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STACK, StackClass))
#define IS_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STACK))
#define IS_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STACK))
#define STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STACK, StackClass))

typedef struct _Stack Stack;
typedef struct _StackClass StackClass;
typedef struct _StackPrivate StackPrivate;
enum  {
	STACK_0_PROPERTY,
	STACK_T_TYPE,
	STACK_T_DUP_FUNC,
	STACK_T_DESTROY_FUNC,
	STACK_NUM_PROPERTIES
};
static GParamSpec* stack_properties[STACK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Stack {
	GObject parent_instance;
	StackPrivate * priv;
};

struct _StackClass {
	GObjectClass parent_class;
};

struct _StackPrivate {
	GType t_type;
	GBoxedCopyFunc t_dup_func;
	GDestroyNotify t_destroy_func;
	GeeArrayList* list;
};

static gint Stack_private_offset;
static gpointer stack_parent_class = NULL;

VALA_EXTERN GType stack_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Stack, g_object_unref)
VALA_EXTERN Stack* stack_new (GType t_type,
                  GBoxedCopyFunc t_dup_func,
                  GDestroyNotify t_destroy_func);
VALA_EXTERN Stack* stack_construct (GType object_type,
                        GType t_type,
                        GBoxedCopyFunc t_dup_func,
                        GDestroyNotify t_destroy_func);
VALA_EXTERN gsize stack_size (Stack* self);
VALA_EXTERN void stack_push (Stack* self,
                 gconstpointer item);
VALA_EXTERN gpointer stack_peek (Stack* self);
VALA_EXTERN gpointer stack_pop (Stack* self);
static void stack_finalize (GObject * obj);
static GType stack_get_type_once (void);
static void _vala_stack_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_stack_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);

static inline gpointer
stack_get_instance_private (Stack* self)
{
	return G_STRUCT_MEMBER_P (self, Stack_private_offset);
}

Stack*
stack_construct (GType object_type,
                 GType t_type,
                 GBoxedCopyFunc t_dup_func,
                 GDestroyNotify t_destroy_func)
{
	Stack * self = NULL;
	GeeArrayList* _tmp0_;
	self = (Stack*) g_object_new (object_type, "t-type", t_type, "t-dup-func", t_dup_func, "t-destroy-func", t_destroy_func, NULL);
	self->priv->t_type = t_type;
	self->priv->t_dup_func = t_dup_func;
	self->priv->t_destroy_func = t_destroy_func;
	_tmp0_ = gee_array_list_new (t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->list);
	self->priv->list = _tmp0_;
	return self;
}

Stack*
stack_new (GType t_type,
           GBoxedCopyFunc t_dup_func,
           GDestroyNotify t_destroy_func)
{
	return stack_construct (TYPE_STACK, t_type, t_dup_func, t_destroy_func);
}

gsize
stack_size (Stack* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gsize result;
	g_return_val_if_fail (self != NULL, 0UL);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = (gsize) _tmp2_;
	return result;
}

void
stack_push (Stack* self,
            gconstpointer item)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->list;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, item);
}

gpointer
stack_peek (Stack* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gpointer _tmp4_;
	gpointer result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->list;
	_tmp1_ = self->priv->list;
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, _tmp3_ - 1);
	result = _tmp4_;
	return result;
}

gpointer
stack_pop (Stack* self)
{
	gpointer item = NULL;
	gpointer _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gpointer _tmp5_;
	gpointer _tmp6_;
	gpointer result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = stack_peek (self);
	item = _tmp0_;
	_tmp1_ = self->priv->list;
	_tmp2_ = self->priv->list;
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp1_, _tmp4_ - 1);
	_tmp6_ = _tmp5_;
	((_tmp6_ == NULL) || (self->priv->t_destroy_func == NULL)) ? NULL : (_tmp6_ = (self->priv->t_destroy_func (_tmp6_), NULL));
	result = item;
	return result;
}

static void
stack_class_init (StackClass * klass,
                  gpointer klass_data)
{
	stack_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Stack_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_stack_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_stack_set_property;
	G_OBJECT_CLASS (klass)->finalize = stack_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), STACK_T_TYPE, g_param_spec_gtype ("t-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STACK_T_DUP_FUNC, g_param_spec_pointer ("t-dup-func", "dup func", "dup func", G_PARAM_STATIC_STRINGS | G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STACK_T_DESTROY_FUNC, g_param_spec_pointer ("t-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_STRINGS | G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
}

static void
stack_instance_init (Stack * self,
                     gpointer klass)
{
	self->priv = stack_get_instance_private (self);
}

static void
stack_finalize (GObject * obj)
{
	Stack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STACK, Stack);
	_g_object_unref0 (self->priv->list);
	G_OBJECT_CLASS (stack_parent_class)->finalize (obj);
}

static GType
stack_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) stack_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Stack), 0, (GInstanceInitFunc) stack_instance_init, NULL };
	GType stack_type_id;
	stack_type_id = g_type_register_static (G_TYPE_OBJECT, "Stack", &g_define_type_info, 0);
	Stack_private_offset = g_type_add_instance_private (stack_type_id, sizeof (StackPrivate));
	return stack_type_id;
}

GType
stack_get_type (void)
{
	static volatile gsize stack_type_id__once = 0;
	if (g_once_init_enter (&stack_type_id__once)) {
		GType stack_type_id;
		stack_type_id = stack_get_type_once ();
		g_once_init_leave (&stack_type_id__once, stack_type_id);
	}
	return stack_type_id__once;
}

static void
_vala_stack_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Stack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_STACK, Stack);
	switch (property_id) {
		case STACK_T_TYPE:
		g_value_set_gtype (value, self->priv->t_type);
		break;
		case STACK_T_DUP_FUNC:
		g_value_set_pointer (value, self->priv->t_dup_func);
		break;
		case STACK_T_DESTROY_FUNC:
		g_value_set_pointer (value, self->priv->t_destroy_func);
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_stack_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Stack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_STACK, Stack);
	switch (property_id) {
		case STACK_T_TYPE:
		self->priv->t_type = g_value_get_gtype (value);
		break;
		case STACK_T_DUP_FUNC:
		self->priv->t_dup_func = g_value_get_pointer (value);
		break;
		case STACK_T_DESTROY_FUNC:
		self->priv->t_destroy_func = g_value_get_pointer (value);
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

