/* state-choose-category.c generated by valac 0.56.17, the Vala compiler
 * generated from state-choose-category.vala, do not modify */

/*   FILE: state-choose-category.vala -- A state machine implementing lcdgrilo's menu
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 01 December 2013 
 *
 * Copyright (c) 2013 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * stop:        stop currently playing and clear playlist.
 * pauseplay:   pause if playing else transition from paused to playing.
 * seekback:    no operation.
 * seekforward: no operation.
 * next:        select next menu item.
 * previous:    select previous menu item.
 * transition:  enter folder, display more, play all or play; state to
 *              StateConnecting (StateChooseCategory), StateConnecting (self) or
 *              StatePlay.
 */

#include <glib.h>
#include <glib-object.h>
#include <grilo.h>
#include <string.h>
#include <stdlib.h>
#include <gee.h>
#include <gst/gst.h>
#include <gobject/gvaluecollector.h>

#define PAGE_SIZE 100
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	CATEGORY_TYPE_BOX,
	CATEGORY_TYPE_MORE,
	CATEGORY_TYPE_TRACK,
	CATEGORY_TYPE_PLAYALL
} CategoryType;

#define TYPE_CATEGORY_TYPE (category_type_get_type ())

#define TYPE_CATEGORY (category_get_type ())
typedef struct _Category Category;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_STATE (state_get_type ())
#define STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE, State))
#define STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE, StateClass))
#define IS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE))
#define IS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE))
#define STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE, StateClass))

typedef struct _State State;
typedef struct _StateClass StateClass;
typedef struct _StatePrivate StatePrivate;

#define TYPE_LCD_PLAYER (lcd_player_get_type ())
#define LCD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LCD_PLAYER, LCDPlayer))
#define LCD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LCD_PLAYER, LCDPlayerClass))
#define IS_LCD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LCD_PLAYER))
#define IS_LCD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LCD_PLAYER))
#define LCD_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LCD_PLAYER, LCDPlayerClass))

typedef struct _LCDPlayer LCDPlayer;
typedef struct _LCDPlayerClass LCDPlayerClass;

#define TYPE_STATE_CHOOSE_CATEGORY (state_choose_category_get_type ())
#define STATE_CHOOSE_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE_CHOOSE_CATEGORY, StateChooseCategory))
#define STATE_CHOOSE_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE_CHOOSE_CATEGORY, StateChooseCategoryClass))
#define IS_STATE_CHOOSE_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE_CHOOSE_CATEGORY))
#define IS_STATE_CHOOSE_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE_CHOOSE_CATEGORY))
#define STATE_CHOOSE_CATEGORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE_CHOOSE_CATEGORY, StateChooseCategoryClass))

typedef struct _StateChooseCategory StateChooseCategory;
typedef struct _StateChooseCategoryClass StateChooseCategoryClass;
typedef struct _StateChooseCategoryPrivate StateChooseCategoryPrivate;

#define STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER (state_choose_category_child_media_list_builder_get_type ())
#define STATE_CHOOSE_CATEGORY_CHILD_MEDIA_LIST_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER, StateChooseCategoryChildMediaListBuilder))
#define STATE_CHOOSE_CATEGORY_CHILD_MEDIA_LIST_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER, StateChooseCategoryChildMediaListBuilderClass))
#define STATE_CHOOSE_CATEGORY_IS_CHILD_MEDIA_LIST_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER))
#define STATE_CHOOSE_CATEGORY_IS_CHILD_MEDIA_LIST_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER))
#define STATE_CHOOSE_CATEGORY_CHILD_MEDIA_LIST_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER, StateChooseCategoryChildMediaListBuilderClass))

typedef struct _StateChooseCategoryChildMediaListBuilder StateChooseCategoryChildMediaListBuilder;
typedef struct _StateChooseCategoryChildMediaListBuilderClass StateChooseCategoryChildMediaListBuilderClass;
enum  {
	STATE_CHOOSE_CATEGORY_0_PROPERTY,
	STATE_CHOOSE_CATEGORY_NUM_PROPERTIES
};
static GParamSpec* state_choose_category_properties[STATE_CHOOSE_CATEGORY_NUM_PROPERTIES];
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _state_choose_category_child_media_list_builder_unref0(var) ((var == NULL) ? NULL : (var = (state_choose_category_child_media_list_builder_unref (var), NULL)))

#define TYPE_STACK (stack_get_type ())
#define STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STACK, Stack))
#define STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STACK, StackClass))
#define IS_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STACK))
#define IS_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STACK))
#define STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STACK, StackClass))

typedef struct _Stack Stack;
typedef struct _StackClass StackClass;

#define TYPE_STATE_CONNECTING (state_connecting_get_type ())
#define STATE_CONNECTING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE_CONNECTING, StateConnecting))
#define STATE_CONNECTING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE_CONNECTING, StateConnectingClass))
#define IS_STATE_CONNECTING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE_CONNECTING))
#define IS_STATE_CONNECTING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE_CONNECTING))
#define STATE_CONNECTING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE_CONNECTING, StateConnectingClass))

typedef struct _StateConnecting StateConnecting;
typedef struct _StateConnectingClass StateConnectingClass;
#define _category_free0(var) ((var == NULL) ? NULL : (var = (category_free (var), NULL)))
typedef struct _LCDPlayerPrivate LCDPlayerPrivate;

#define TYPE_INPUT_OUTPUT (input_output_get_type ())
#define INPUT_OUTPUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INPUT_OUTPUT, InputOutput))
#define INPUT_OUTPUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INPUT_OUTPUT, InputOutputClass))
#define IS_INPUT_OUTPUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INPUT_OUTPUT))
#define IS_INPUT_OUTPUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INPUT_OUTPUT))
#define INPUT_OUTPUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INPUT_OUTPUT, InputOutputClass))

typedef struct _InputOutput InputOutput;
typedef struct _InputOutputClass InputOutputClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define TYPE_STATE_PLAY (state_play_get_type ())
#define STATE_PLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE_PLAY, StatePlay))
#define STATE_PLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE_PLAY, StatePlayClass))
#define IS_STATE_PLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE_PLAY))
#define IS_STATE_PLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE_PLAY))
#define STATE_PLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE_PLAY, StatePlayClass))

typedef struct _StatePlay StatePlay;
typedef struct _StatePlayClass StatePlayClass;
typedef struct _StateChooseCategoryChildMediaListBuilderPrivate StateChooseCategoryChildMediaListBuilderPrivate;
typedef struct _StateChooseCategoryParamSpecChildMediaListBuilder StateChooseCategoryParamSpecChildMediaListBuilder;
typedef gchar* (*StateChooseCategoryGetFunc) (GrlMedia* media, gpointer user_data);
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Category {
	CategoryType type;
	GrlMedia* media;
};

struct _State {
	GObject parent_instance;
	StatePrivate * priv;
	LCDPlayer* player;
};

struct _StateClass {
	GObjectClass parent_class;
	void (*print_selected) (State* self);
	void (*seekback) (State* self);
	void (*seekforward) (State* self);
	void (*next) (State* self);
	void (*previous) (State* self);
	State* (*transition) (State* self);
};

struct _StateChooseCategory {
	State parent_instance;
	StateChooseCategoryPrivate * priv;
};

struct _StateChooseCategoryClass {
	StateClass parent_class;
};

struct _StateChooseCategoryPrivate {
	gint page;
	GrlMedia* parent_selection;
	GMainLoop* loop;
	GrlSource* source;
	GeeArrayList* categories;
	gint current;
	GrlMedia* canary;
	GeeArrayList* media;
	StateChooseCategoryChildMediaListBuilder* child_media_list_builder;
};

struct _LCDPlayer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LCDPlayerPrivate * priv;
	GstElement* element;
	GeeArrayList* playlist;
	InputOutput* io;
};

struct _LCDPlayerClass {
	GTypeClass parent_class;
	void (*finalize) (LCDPlayer *self);
};

struct _StateChooseCategoryChildMediaListBuilder {
	GTypeInstance parent_instance;
	volatile int ref_count;
	StateChooseCategoryChildMediaListBuilderPrivate * priv;
};

struct _StateChooseCategoryChildMediaListBuilderClass {
	GTypeClass parent_class;
	void (*finalize) (StateChooseCategoryChildMediaListBuilder *self);
};

struct _StateChooseCategoryChildMediaListBuilderPrivate {
	StateChooseCategory* state;
	guint count;
};

struct _StateChooseCategoryParamSpecChildMediaListBuilder {
	GParamSpec parent_instance;
};

static gint StateChooseCategory_private_offset;
static gpointer state_choose_category_parent_class = NULL;
static gint StateChooseCategoryChildMediaListBuilder_private_offset;
static gpointer state_choose_category_child_media_list_builder_parent_class = NULL;

VALA_EXTERN GType category_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Category* category_dup (const Category* self);
VALA_EXTERN void category_free (Category* self);
VALA_EXTERN void category_copy (const Category* self,
                    Category* dest);
VALA_EXTERN void category_destroy (Category* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (Category, category_destroy)
VALA_EXTERN void category_init (Category *self,
                    CategoryType type,
                    GrlMedia* media);
VALA_EXTERN gint media_compare (GrlMedia* m1,
                    GrlMedia* m2);
VALA_EXTERN GType state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (State, g_object_unref)
VALA_EXTERN gpointer lcd_player_ref (gpointer instance);
VALA_EXTERN void lcd_player_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_lcd_player (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_lcd_player (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_lcd_player (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_lcd_player (const GValue* value);
VALA_EXTERN GType lcd_player_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LCDPlayer, lcd_player_unref)
VALA_EXTERN GType state_choose_category_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (StateChooseCategory, g_object_unref)
static gpointer state_choose_category_child_media_list_builder_ref (gpointer instance);
static void state_choose_category_child_media_list_builder_unref (gpointer instance);
static GParamSpec* state_choose_category_param_spec_child_media_list_builder (const gchar* name,
                                                                       const gchar* nick,
                                                                       const gchar* blurb,
                                                                       GType object_type,
                                                                       GParamFlags flags) G_GNUC_UNUSED ;
static void state_choose_category_value_set_child_media_list_builder (GValue* value,
                                                               gpointer v_object) G_GNUC_UNUSED ;
static void state_choose_category_value_take_child_media_list_builder (GValue* value,
                                                                gpointer v_object) G_GNUC_UNUSED ;
static gpointer state_choose_category_value_get_child_media_list_builder (const GValue* value) G_GNUC_UNUSED ;
static GType state_choose_category_child_media_list_builder_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (StateChooseCategoryChildMediaListBuilder, state_choose_category_child_media_list_builder_unref)
VALA_EXTERN void state_print_selected (State* self);
VALA_EXTERN void state_seekback (State* self);
VALA_EXTERN void state_seekforward (State* self);
VALA_EXTERN void state_next (State* self);
VALA_EXTERN void state_previous (State* self);
VALA_EXTERN State* state_transition (State* self);
VALA_EXTERN void state_choose_category_connected_cb (StateChooseCategory* self,
                                         GrlSource* source);
VALA_EXTERN GType stack_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Stack, g_object_unref)
VALA_EXTERN Stack* lcd_player_get_stateStack (LCDPlayer* self);
VALA_EXTERN gpointer stack_pop (Stack* self);
VALA_EXTERN GType state_connecting_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (StateConnecting, g_object_unref)
VALA_EXTERN void state_choose_category_build_menu (StateChooseCategory* self);
VALA_EXTERN gpointer stack_peek (Stack* self);
VALA_EXTERN void stack_push (Stack* self,
                 gconstpointer item);
VALA_EXTERN void state_choose_category_add_media (StateChooseCategory* self,
                                      GrlMedia* media);
VALA_EXTERN StateChooseCategory* state_choose_category_new (GMainLoop* loop,
                                                LCDPlayer* player,
                                                GrlSource* source,
                                                GrlMedia* parent_selection);
VALA_EXTERN StateChooseCategory* state_choose_category_construct (GType object_type,
                                                      GMainLoop* loop,
                                                      LCDPlayer* player,
                                                      GrlSource* source,
                                                      GrlMedia* parent_selection);
VALA_EXTERN State* state_construct (GType object_type);
static void state_choose_category_real_print_selected (State* base);
VALA_EXTERN GType input_output_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (InputOutput, g_object_unref)
VALA_EXTERN void input_output_output (InputOutput* self,
                          const gchar* str);
static void state_choose_category_real_seekback (State* base);
static void state_choose_category_real_seekforward (State* base);
static void state_choose_category_real_next (State* base);
static void state_choose_category_real_previous (State* base);
static State* state_choose_category_real_transition (State* base);
static StateChooseCategoryChildMediaListBuilder* state_choose_category_child_media_list_builder_new (StateChooseCategory* state);
static StateChooseCategoryChildMediaListBuilder* state_choose_category_child_media_list_builder_construct (GType object_type,
                                                                                                    StateChooseCategory* state);
static void state_choose_category_child_media_list_builder_browse_cb (StateChooseCategoryChildMediaListBuilder* self,
                                                               GrlSource* source,
                                                               guint operation_id,
                                                               GrlMedia* media,
                                                               guint remaining,
                                                               GError* _error_);
static void _state_choose_category_child_media_list_builder_browse_cb_grl_source_result_cb (GrlSource* source,
                                                                                     guint operation_id,
                                                                                     GrlMedia* media,
                                                                                     guint remaining,
                                                                                     gpointer self,
                                                                                     GError* _error_);
VALA_EXTERN StateConnecting* state_connecting_new (GMainLoop* loop,
                                       LCDPlayer* player,
                                       const gchar* target_name,
                                       State* next_state);
VALA_EXTERN StateConnecting* state_connecting_construct (GType object_type,
                                             GMainLoop* loop,
                                             LCDPlayer* player,
                                             const gchar* target_name,
                                             State* next_state);
static gint _media_compare_gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
VALA_EXTERN StatePlay* state_play_new (LCDPlayer* player);
VALA_EXTERN StatePlay* state_play_construct (GType object_type,
                                 LCDPlayer* player);
VALA_EXTERN GType state_play_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (StatePlay, g_object_unref)
static void state_choose_category_child_media_list_builder_finalize (StateChooseCategoryChildMediaListBuilder * obj);
static GType state_choose_category_child_media_list_builder_get_type_once (void);
static void state_choose_category_finalize (GObject * obj);
static GType state_choose_category_get_type_once (void);

static GType
category_type_get_type_once (void)
{
	static const GEnumValue values[] = {{CATEGORY_TYPE_BOX, "CATEGORY_TYPE_BOX", "box"}, {CATEGORY_TYPE_MORE, "CATEGORY_TYPE_MORE", "more"}, {CATEGORY_TYPE_TRACK, "CATEGORY_TYPE_TRACK", "track"}, {CATEGORY_TYPE_PLAYALL, "CATEGORY_TYPE_PLAYALL", "playall"}, {0, NULL, NULL}};
	GType category_type_type_id;
	category_type_type_id = g_enum_register_static ("CategoryType", values);
	return category_type_type_id;
}

GType
category_type_get_type (void)
{
	static volatile gsize category_type_type_id__once = 0;
	if (g_once_init_enter (&category_type_type_id__once)) {
		GType category_type_type_id;
		category_type_type_id = category_type_get_type_once ();
		g_once_init_leave (&category_type_type_id__once, category_type_type_id);
	}
	return category_type_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
category_init (Category *self,
               CategoryType type,
               GrlMedia* media)
{
	GrlMedia* _tmp0_;
	memset (self, 0, sizeof (Category));
	(*self).type = type;
	_tmp0_ = _g_object_ref0 (media);
	_g_object_unref0 ((*self).media);
	(*self).media = _tmp0_;
}

void
category_copy (const Category* self,
               Category* dest)
{
	GrlMedia* _tmp0_;
	GrlMedia* _tmp1_;
	(*dest).type = (*self).type;
	_tmp0_ = (*self).media;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 ((*dest).media);
	(*dest).media = _tmp1_;
}

void
category_destroy (Category* self)
{
	_g_object_unref0 ((*self).media);
}

Category*
category_dup (const Category* self)
{
	Category* dup;
	dup = g_new0 (Category, 1);
	category_copy (self, dup);
	return dup;
}

void
category_free (Category* self)
{
	category_destroy (self);
	g_free (self);
}

static GType
category_get_type_once (void)
{
	GType category_type_id;
	category_type_id = g_boxed_type_register_static ("Category", (GBoxedCopyFunc) category_dup, (GBoxedFreeFunc) category_free);
	return category_type_id;
}

GType
category_get_type (void)
{
	static volatile gsize category_type_id__once = 0;
	if (g_once_init_enter (&category_type_id__once)) {
		GType category_type_id;
		category_type_id = category_get_type_once ();
		g_once_init_leave (&category_type_id__once, category_type_id);
	}
	return category_type_id__once;
}

gint
media_compare (GrlMedia* m1,
               GrlMedia* m2)
{
	gboolean _tmp0_ = FALSE;
	gint result;
	g_return_val_if_fail (m1 != NULL, 0);
	g_return_val_if_fail (m2 != NULL, 0);
	if (grl_media_is_audio (m1)) {
		_tmp0_ = grl_media_is_audio (m2);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint disc1 = 0;
		gint disc2 = 0;
		disc1 = grl_media_get_album_disc_number (G_TYPE_CHECK_INSTANCE_CAST (m1, grl_media_get_type (), GrlMedia));
		disc2 = grl_media_get_album_disc_number (G_TYPE_CHECK_INSTANCE_CAST (m2, grl_media_get_type (), GrlMedia));
		if (disc1 != disc2) {
			result = disc1 - disc2;
			return result;
		} else {
			gint track1 = 0;
			gint track2 = 0;
			track1 = grl_media_get_track_number (G_TYPE_CHECK_INSTANCE_CAST (m1, grl_media_get_type (), GrlMedia));
			track2 = grl_media_get_track_number (G_TYPE_CHECK_INSTANCE_CAST (m2, grl_media_get_type (), GrlMedia));
			result = track1 - track2;
			return result;
		}
	} else {
		GCompareFunc _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp1_ = ((GCompareFunc) g_strcmp0);
		_tmp2_ = grl_media_get_title (m1);
		_tmp3_ = grl_media_get_title (m2);
		result = _tmp1_ (_tmp2_, _tmp3_);
		return result;
	}
}

static inline gpointer
state_choose_category_get_instance_private (StateChooseCategory* self)
{
	return G_STRUCT_MEMBER_P (self, StateChooseCategory_private_offset);
}

void
state_choose_category_connected_cb (StateChooseCategory* self,
                                    GrlSource* source)
{
	State* state = NULL;
	LCDPlayer* _tmp0_;
	Stack* _tmp1_;
	Stack* _tmp2_;
	gpointer _tmp3_;
	State* _tmp4_;
	State* next_state = NULL;
	State* _tmp5_;
	State* _tmp6_;
	State* _tmp7_;
	State* _tmp8_;
	State* _tmp9_;
	LCDPlayer* _tmp10_;
	Stack* _tmp11_;
	Stack* _tmp12_;
	gpointer _tmp13_;
	State* _tmp14_;
	gboolean _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = ((State*) self)->player;
	_tmp1_ = lcd_player_get_stateStack (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = stack_pop (_tmp2_);
	state = (State*) _tmp3_;
	_tmp4_ = state;
	_vala_assert (IS_STATE_CONNECTING (_tmp4_), "state is StateConnecting");
	_tmp5_ = state;
	_tmp6_ = state_transition (_tmp5_);
	next_state = _tmp6_;
	_tmp7_ = next_state;
	_vala_assert (IS_STATE_CHOOSE_CATEGORY (_tmp7_), "next_state is StateChooseCategory");
	_tmp8_ = next_state;
	state_choose_category_build_menu (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_STATE_CHOOSE_CATEGORY, StateChooseCategory));
	_tmp9_ = next_state;
	_tmp10_ = ((State*) self)->player;
	_tmp11_ = lcd_player_get_stateStack (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = stack_peek (_tmp12_);
	_tmp14_ = (State*) _tmp13_;
	_tmp15_ = _tmp9_ != _tmp14_;
	_g_object_unref0 (_tmp14_);
	if (_tmp15_) {
		LCDPlayer* _tmp16_;
		Stack* _tmp17_;
		Stack* _tmp18_;
		State* _tmp19_;
		_tmp16_ = ((State*) self)->player;
		_tmp17_ = lcd_player_get_stateStack (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = next_state;
		stack_push (_tmp18_, _tmp19_);
	}
	_g_object_unref0 (next_state);
	_g_object_unref0 (state);
}

void
state_choose_category_add_media (StateChooseCategory* self,
                                 GrlMedia* media)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (media != NULL);
	_tmp0_ = self->priv->media;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, media);
}

static gpointer
_g_main_loop_ref0 (gpointer self)
{
	return self ? g_main_loop_ref (self) : NULL;
}

StateChooseCategory*
state_choose_category_construct (GType object_type,
                                 GMainLoop* loop,
                                 LCDPlayer* player,
                                 GrlSource* source,
                                 GrlMedia* parent_selection)
{
	StateChooseCategory * self = NULL;
	GMainLoop* _tmp0_;
	GrlSource* _tmp1_;
	GrlMedia* _tmp2_;
	g_return_val_if_fail (loop != NULL, NULL);
	g_return_val_if_fail (player != NULL, NULL);
	g_return_val_if_fail (source != NULL, NULL);
	self = (StateChooseCategory*) state_construct (object_type);
	_tmp0_ = _g_main_loop_ref0 (loop);
	_g_main_loop_unref0 (self->priv->loop);
	self->priv->loop = _tmp0_;
	((State*) self)->player = player;
	_tmp1_ = _g_object_ref0 (source);
	_g_object_unref0 (self->priv->source);
	self->priv->source = _tmp1_;
	_tmp2_ = _g_object_ref0 (parent_selection);
	_g_object_unref0 (self->priv->parent_selection);
	self->priv->parent_selection = _tmp2_;
	return self;
}

StateChooseCategory*
state_choose_category_new (GMainLoop* loop,
                           LCDPlayer* player,
                           GrlSource* source,
                           GrlMedia* parent_selection)
{
	return state_choose_category_construct (TYPE_STATE_CHOOSE_CATEGORY, loop, player, source, parent_selection);
}

void
state_choose_category_build_menu (StateChooseCategory* self)
{
	gboolean have_media = FALSE;
	GeeArrayList* _tmp0_;
	GrlMedia* _tmp24_;
	g_return_if_fail (self != NULL);
	have_media = FALSE;
	_tmp0_ = gee_array_list_new (TYPE_CATEGORY, (GBoxedCopyFunc) category_dup, (GDestroyNotify) category_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->categories);
	self->priv->categories = _tmp0_;
	{
		GeeArrayList* _m_list = NULL;
		GeeArrayList* _tmp1_;
		gint _m_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _m_index = 0;
		_tmp1_ = self->priv->media;
		_m_list = _tmp1_;
		_tmp2_ = _m_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_m_size = _tmp4_;
		_m_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			GrlMedia* m = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			GrlMedia* _tmp9_;
			_m_index = _m_index + 1;
			_tmp5_ = _m_index;
			_tmp6_ = _m_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _m_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _m_index);
			m = (GrlMedia*) _tmp8_;
			_tmp9_ = m;
			if (grl_media_is_container (_tmp9_)) {
				GeeArrayList* _tmp10_;
				GrlMedia* _tmp11_;
				Category _tmp12_ = {0};
				Category _tmp13_;
				Category _tmp14_;
				_tmp10_ = self->priv->categories;
				_tmp11_ = m;
				category_init (&_tmp12_, CATEGORY_TYPE_BOX, _tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = _tmp13_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, &_tmp14_);
				category_destroy (&_tmp13_);
			} else {
				GeeArrayList* _tmp15_;
				GrlMedia* _tmp16_;
				Category _tmp17_ = {0};
				Category _tmp18_;
				Category _tmp19_;
				have_media = TRUE;
				_tmp15_ = self->priv->categories;
				_tmp16_ = m;
				category_init (&_tmp17_, CATEGORY_TYPE_TRACK, _tmp16_);
				_tmp18_ = _tmp17_;
				_tmp19_ = _tmp18_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, &_tmp19_);
				category_destroy (&_tmp18_);
			}
			_g_object_unref0 (m);
		}
	}
	if (TRUE == have_media) {
		GeeArrayList* _tmp20_;
		Category _tmp21_ = {0};
		Category _tmp22_;
		Category _tmp23_;
		_tmp20_ = self->priv->categories;
		category_init (&_tmp21_, CATEGORY_TYPE_PLAYALL, NULL);
		_tmp22_ = _tmp21_;
		_tmp23_ = _tmp22_;
		gee_abstract_list_insert ((GeeAbstractList*) _tmp20_, 0, &_tmp23_);
		category_destroy (&_tmp22_);
	}
	_tmp24_ = self->priv->canary;
	if (NULL != _tmp24_) {
		GeeArrayList* _tmp25_;
		Category _tmp26_ = {0};
		Category _tmp27_;
		Category _tmp28_;
		_tmp25_ = self->priv->categories;
		category_init (&_tmp26_, CATEGORY_TYPE_MORE, NULL);
		_tmp27_ = _tmp26_;
		_tmp28_ = _tmp27_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, &_tmp28_);
		category_destroy (&_tmp27_);
	}
	state_print_selected ((State*) self);
}

static void
state_choose_category_real_print_selected (State* base)
{
	StateChooseCategory * self;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	Category* _tmp2_;
	CategoryType _tmp3_;
	self = (StateChooseCategory*) base;
	_tmp0_ = self->priv->categories;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, self->priv->current);
	_tmp2_ = (Category*) _tmp1_;
	_tmp3_ = (*_tmp2_).type;
	_category_free0 (_tmp2_);
	switch (_tmp3_) {
		case CATEGORY_TYPE_BOX:
		{
			LCDPlayer* _tmp4_;
			InputOutput* _tmp5_;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			Category* _tmp8_;
			GrlMedia* _tmp9_;
			const gchar* _tmp10_;
			_tmp4_ = ((State*) self)->player;
			_tmp5_ = _tmp4_->io;
			_tmp6_ = self->priv->categories;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, self->priv->current);
			_tmp8_ = (Category*) _tmp7_;
			_tmp9_ = (*_tmp8_).media;
			_tmp10_ = grl_media_get_title (_tmp9_);
			input_output_output (_tmp5_, _tmp10_);
			_category_free0 (_tmp8_);
			break;
		}
		case CATEGORY_TYPE_TRACK:
		{
			GString* builder = NULL;
			GString* _tmp11_;
			GeeArrayList* _tmp12_;
			gpointer _tmp13_;
			Category* _tmp14_;
			GrlMedia* _tmp15_;
			gboolean _tmp16_;
			GString* _tmp35_;
			GeeArrayList* _tmp36_;
			gpointer _tmp37_;
			Category* _tmp38_;
			GrlMedia* _tmp39_;
			const gchar* _tmp40_;
			LCDPlayer* _tmp41_;
			InputOutput* _tmp42_;
			GString* _tmp43_;
			const gchar* _tmp44_;
			_tmp11_ = g_string_new ("");
			builder = _tmp11_;
			_tmp12_ = self->priv->categories;
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, self->priv->current);
			_tmp14_ = (Category*) _tmp13_;
			_tmp15_ = (*_tmp14_).media;
			_tmp16_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, grl_media_get_type ());
			_category_free0 (_tmp14_);
			if (_tmp16_) {
				gint disc = 0;
				GeeArrayList* _tmp17_;
				gpointer _tmp18_;
				Category* _tmp19_;
				GrlMedia* _tmp20_;
				gint _tmp21_;
				gint track = 0;
				GeeArrayList* _tmp22_;
				gpointer _tmp23_;
				Category* _tmp24_;
				GrlMedia* _tmp25_;
				gint _tmp26_;
				_tmp17_ = self->priv->categories;
				_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, self->priv->current);
				_tmp19_ = (Category*) _tmp18_;
				_tmp20_ = (*_tmp19_).media;
				_tmp21_ = grl_media_get_album_disc_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, grl_media_get_type (), GrlMedia));
				_category_free0 (_tmp19_);
				disc = _tmp21_;
				_tmp22_ = self->priv->categories;
				_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, self->priv->current);
				_tmp24_ = (Category*) _tmp23_;
				_tmp25_ = (*_tmp24_).media;
				_tmp26_ = grl_media_get_track_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, grl_media_get_type (), GrlMedia));
				_category_free0 (_tmp24_);
				track = _tmp26_;
				if (track != 0) {
					GString* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					GString* _tmp30_;
					GString* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					GString* _tmp34_;
					_tmp27_ = builder;
					_tmp28_ = g_strdup_printf ("%i", disc);
					_tmp29_ = _tmp28_;
					g_string_append (_tmp27_, _tmp29_);
					_g_free0 (_tmp29_);
					_tmp30_ = builder;
					g_string_append (_tmp30_, "-");
					_tmp31_ = builder;
					_tmp32_ = g_strdup_printf ("%i", track);
					_tmp33_ = _tmp32_;
					g_string_append (_tmp31_, _tmp33_);
					_g_free0 (_tmp33_);
					_tmp34_ = builder;
					g_string_append (_tmp34_, ". ");
				}
			}
			_tmp35_ = builder;
			_tmp36_ = self->priv->categories;
			_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, self->priv->current);
			_tmp38_ = (Category*) _tmp37_;
			_tmp39_ = (*_tmp38_).media;
			_tmp40_ = grl_media_get_title (_tmp39_);
			g_string_append (_tmp35_, _tmp40_);
			_category_free0 (_tmp38_);
			_tmp41_ = ((State*) self)->player;
			_tmp42_ = _tmp41_->io;
			_tmp43_ = builder;
			_tmp44_ = _tmp43_->str;
			input_output_output (_tmp42_, _tmp44_);
			_g_string_free0 (builder);
			break;
		}
		case CATEGORY_TYPE_MORE:
		{
			LCDPlayer* _tmp45_;
			InputOutput* _tmp46_;
			_tmp45_ = ((State*) self)->player;
			_tmp46_ = _tmp45_->io;
			input_output_output (_tmp46_, "More...");
			break;
		}
		case CATEGORY_TYPE_PLAYALL:
		{
			LCDPlayer* _tmp47_;
			InputOutput* _tmp48_;
			_tmp47_ = ((State*) self)->player;
			_tmp48_ = _tmp47_->io;
			input_output_output (_tmp48_, "Play all");
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static void
state_choose_category_real_seekback (State* base)
{
	StateChooseCategory * self;
	self = (StateChooseCategory*) base;
}

static void
state_choose_category_real_seekforward (State* base)
{
	StateChooseCategory * self;
	self = (StateChooseCategory*) base;
}

static void
state_choose_category_real_next (State* base)
{
	StateChooseCategory * self;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	self = (StateChooseCategory*) base;
	_tmp0_ = self->priv->categories;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	self->priv->current = (self->priv->current + 1) % _tmp2_;
	state_print_selected ((State*) self);
}

static void
state_choose_category_real_previous (State* base)
{
	StateChooseCategory * self;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	self = (StateChooseCategory*) base;
	_tmp0_ = self->priv->categories;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->categories;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	self->priv->current = ((self->priv->current + _tmp2_) - 1) % _tmp5_;
	state_print_selected ((State*) self);
}

static void
_state_choose_category_child_media_list_builder_browse_cb_grl_source_result_cb (GrlSource* source,
                                                                                guint operation_id,
                                                                                GrlMedia* media,
                                                                                guint remaining,
                                                                                gpointer self,
                                                                                GError* _error_)
{
	state_choose_category_child_media_list_builder_browse_cb ((StateChooseCategoryChildMediaListBuilder*) self, source, operation_id, media, remaining, _error_);
}

static gint
_media_compare_gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = media_compare ((GrlMedia*) a, (GrlMedia*) b);
	return result;
}

static State*
state_choose_category_real_transition (State* base)
{
	StateChooseCategory * self;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	Category* _tmp2_;
	CategoryType _tmp3_;
	State* result;
	self = (StateChooseCategory*) base;
	_tmp0_ = self->priv->categories;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, self->priv->current);
	_tmp2_ = (Category*) _tmp1_;
	_tmp3_ = (*_tmp2_).type;
	_category_free0 (_tmp2_);
	switch (_tmp3_) {
		case CATEGORY_TYPE_BOX:
		{
			GList* keys = NULL;
			GList* _tmp4_;
			GrlCaps* caps = NULL;
			GrlSource* _tmp5_;
			GrlCaps* _tmp6_;
			GrlCaps* _tmp7_;
			GrlOperationOptions* options = NULL;
			GrlCaps* _tmp8_;
			GrlOperationOptions* _tmp9_;
			StateChooseCategory* next_state = NULL;
			GMainLoop* _tmp10_;
			LCDPlayer* _tmp11_;
			GrlSource* _tmp12_;
			GeeArrayList* _tmp13_;
			gpointer _tmp14_;
			Category* _tmp15_;
			GrlMedia* _tmp16_;
			StateChooseCategory* _tmp17_;
			StateChooseCategory* _tmp18_;
			gint _tmp19_;
			GrlOperationOptions* _tmp20_;
			StateChooseCategory* _tmp21_;
			StateChooseCategoryChildMediaListBuilder* _tmp22_;
			GrlSource* _tmp23_;
			GeeArrayList* _tmp24_;
			gpointer _tmp25_;
			Category* _tmp26_;
			GrlMedia* _tmp27_;
			GList* _tmp28_;
			GrlOperationOptions* _tmp29_;
			StateChooseCategoryChildMediaListBuilder* _tmp30_;
			GMainLoop* _tmp31_;
			LCDPlayer* _tmp32_;
			GeeArrayList* _tmp33_;
			gpointer _tmp34_;
			Category* _tmp35_;
			GrlMedia* _tmp36_;
			const gchar* _tmp37_;
			StateChooseCategory* _tmp38_;
			StateConnecting* _tmp39_;
			State* _tmp40_;
			_tmp4_ = grl_metadata_key_list_new (GRL_METADATA_KEY_ALBUM, GRL_METADATA_KEY_ARTIST, GRL_METADATA_KEY_TITLE, GRL_METADATA_KEY_TRACK_NUMBER, GRL_METADATA_KEY_URL, NULL);
			keys = _tmp4_;
			_tmp5_ = self->priv->source;
			_tmp6_ = grl_source_get_caps (_tmp5_, GRL_OP_BROWSE);
			_tmp7_ = _g_object_ref0 (_tmp6_);
			caps = _tmp7_;
			_tmp8_ = caps;
			_tmp9_ = grl_operation_options_new (_tmp8_);
			options = _tmp9_;
			_tmp10_ = self->priv->loop;
			_tmp11_ = ((State*) self)->player;
			_tmp12_ = self->priv->source;
			_tmp13_ = self->priv->categories;
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, self->priv->current);
			_tmp15_ = (Category*) _tmp14_;
			_tmp16_ = (*_tmp15_).media;
			_tmp17_ = state_choose_category_new (_tmp10_, _tmp11_, _tmp12_, _tmp16_);
			_tmp18_ = _tmp17_;
			_category_free0 (_tmp15_);
			next_state = _tmp18_;
			_tmp19_ = self->priv->page;
			self->priv->page = _tmp19_ + 1;
			_tmp20_ = options;
			grl_operation_options_set_count (_tmp20_, PAGE_SIZE);
			_tmp21_ = next_state;
			_tmp22_ = state_choose_category_child_media_list_builder_new (_tmp21_);
			_state_choose_category_child_media_list_builder_unref0 (self->priv->child_media_list_builder);
			self->priv->child_media_list_builder = _tmp22_;
			_tmp23_ = self->priv->source;
			_tmp24_ = self->priv->categories;
			_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, self->priv->current);
			_tmp26_ = (Category*) _tmp25_;
			_tmp27_ = (*_tmp26_).media;
			_tmp28_ = keys;
			_tmp29_ = options;
			_tmp30_ = self->priv->child_media_list_builder;
			grl_source_browse (_tmp23_, _tmp27_, _tmp28_, _tmp29_, _state_choose_category_child_media_list_builder_browse_cb_grl_source_result_cb, _tmp30_);
			_category_free0 (_tmp26_);
			_tmp31_ = self->priv->loop;
			_tmp32_ = ((State*) self)->player;
			_tmp33_ = self->priv->categories;
			_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, self->priv->current);
			_tmp35_ = (Category*) _tmp34_;
			_tmp36_ = (*_tmp35_).media;
			_tmp37_ = grl_media_get_title (_tmp36_);
			_tmp38_ = next_state;
			_tmp39_ = state_connecting_new (_tmp31_, _tmp32_, _tmp37_, (State*) _tmp38_);
			_tmp40_ = (State*) _tmp39_;
			_category_free0 (_tmp35_);
			result = _tmp40_;
			_g_object_unref0 (next_state);
			_g_object_unref0 (options);
			_g_object_unref0 (caps);
			(keys == NULL) ? NULL : (keys = (g_list_free (keys), NULL));
			return result;
		}
		case CATEGORY_TYPE_MORE:
		{
			GeeArrayList* _tmp41_;
			GeeArrayList* _tmp42_;
			gpointer _tmp43_;
			Category* _tmp44_;
			GList* keys = NULL;
			GList* _tmp45_;
			GrlCaps* caps = NULL;
			GrlSource* _tmp46_;
			GrlCaps* _tmp47_;
			GrlCaps* _tmp48_;
			GrlOperationOptions* options = NULL;
			GrlCaps* _tmp49_;
			GrlOperationOptions* _tmp50_;
			gint _tmp51_;
			GrlOperationOptions* _tmp52_;
			GrlOperationOptions* _tmp53_;
			StateChooseCategoryChildMediaListBuilder* _tmp54_;
			GrlSource* _tmp55_;
			GrlMedia* _tmp56_;
			GList* _tmp57_;
			GrlOperationOptions* _tmp58_;
			StateChooseCategoryChildMediaListBuilder* _tmp59_;
			GMainLoop* _tmp60_;
			LCDPlayer* _tmp61_;
			GrlMedia* _tmp62_;
			const gchar* _tmp63_;
			StateConnecting* _tmp64_;
			_tmp41_ = self->priv->categories;
			_tmp42_ = self->priv->categories;
			_tmp43_ = gee_abstract_list_get ((GeeAbstractList*) _tmp42_, self->priv->current);
			_tmp44_ = (Category*) _tmp43_;
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp41_, _tmp44_);
			_category_free0 (_tmp44_);
			_tmp45_ = grl_metadata_key_list_new (GRL_METADATA_KEY_ALBUM, GRL_METADATA_KEY_ARTIST, GRL_METADATA_KEY_TITLE, GRL_METADATA_KEY_TRACK_NUMBER, GRL_METADATA_KEY_URL, NULL);
			keys = _tmp45_;
			_tmp46_ = self->priv->source;
			_tmp47_ = grl_source_get_caps (_tmp46_, GRL_OP_BROWSE);
			_tmp48_ = _g_object_ref0 (_tmp47_);
			caps = _tmp48_;
			_tmp49_ = caps;
			_tmp50_ = grl_operation_options_new (_tmp49_);
			options = _tmp50_;
			_tmp51_ = self->priv->page;
			self->priv->page = _tmp51_ + 1;
			_tmp52_ = options;
			grl_operation_options_set_skip (_tmp52_, (guint) (PAGE_SIZE * self->priv->page));
			_tmp53_ = options;
			grl_operation_options_set_count (_tmp53_, PAGE_SIZE);
			_tmp54_ = state_choose_category_child_media_list_builder_new (self);
			_state_choose_category_child_media_list_builder_unref0 (self->priv->child_media_list_builder);
			self->priv->child_media_list_builder = _tmp54_;
			_tmp55_ = self->priv->source;
			_tmp56_ = self->priv->parent_selection;
			_tmp57_ = keys;
			_tmp58_ = options;
			_tmp59_ = self->priv->child_media_list_builder;
			grl_source_browse (_tmp55_, _tmp56_, _tmp57_, _tmp58_, _state_choose_category_child_media_list_builder_browse_cb_grl_source_result_cb, _tmp59_);
			_tmp60_ = self->priv->loop;
			_tmp61_ = ((State*) self)->player;
			_tmp62_ = self->priv->parent_selection;
			_tmp63_ = grl_media_get_title (_tmp62_);
			_tmp64_ = state_connecting_new (_tmp60_, _tmp61_, _tmp63_, (State*) self);
			result = (State*) _tmp64_;
			_g_object_unref0 (options);
			_g_object_unref0 (caps);
			(keys == NULL) ? NULL : (keys = (g_list_free (keys), NULL));
			return result;
		}
		case CATEGORY_TYPE_PLAYALL:
		{
			LCDPlayer* _tmp77_;
			GeeArrayList* _tmp78_;
			LCDPlayer* _tmp79_;
			StatePlay* _tmp80_;
			{
				GeeArrayList* _m_list = NULL;
				GeeArrayList* _tmp65_;
				gint _m_size = 0;
				GeeArrayList* _tmp66_;
				gint _tmp67_;
				gint _tmp68_;
				gint _m_index = 0;
				_tmp65_ = self->priv->media;
				_m_list = _tmp65_;
				_tmp66_ = _m_list;
				_tmp67_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp66_);
				_tmp68_ = _tmp67_;
				_m_size = _tmp68_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp69_;
					gint _tmp70_;
					GrlMedia* m = NULL;
					GeeArrayList* _tmp71_;
					gpointer _tmp72_;
					GrlMedia* _tmp73_;
					_m_index = _m_index + 1;
					_tmp69_ = _m_index;
					_tmp70_ = _m_size;
					if (!(_tmp69_ < _tmp70_)) {
						break;
					}
					_tmp71_ = _m_list;
					_tmp72_ = gee_abstract_list_get ((GeeAbstractList*) _tmp71_, _m_index);
					m = (GrlMedia*) _tmp72_;
					_tmp73_ = m;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp73_, grl_media_get_type ())) {
						LCDPlayer* _tmp74_;
						GeeArrayList* _tmp75_;
						GrlMedia* _tmp76_;
						_tmp74_ = ((State*) self)->player;
						_tmp75_ = _tmp74_->playlist;
						_tmp76_ = m;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp75_, G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, grl_media_get_type (), GrlMedia));
					}
					_g_object_unref0 (m);
				}
			}
			_tmp77_ = ((State*) self)->player;
			_tmp78_ = _tmp77_->playlist;
			gee_list_sort ((GeeList*) _tmp78_, _media_compare_gcompare_data_func, NULL, NULL);
			_tmp79_ = ((State*) self)->player;
			_tmp80_ = state_play_new (_tmp79_);
			result = (State*) _tmp80_;
			return result;
		}
		case CATEGORY_TYPE_TRACK:
		{
			GeeArrayList* _tmp81_;
			gpointer _tmp82_;
			Category* _tmp83_;
			GrlMedia* _tmp84_;
			GrlMedia* media = NULL;
			GeeArrayList* _tmp85_;
			gpointer _tmp86_;
			Category* _tmp87_;
			GrlMedia* _tmp88_;
			GrlMedia* _tmp89_;
			GrlMedia* _tmp90_;
			LCDPlayer* _tmp91_;
			GeeArrayList* _tmp92_;
			GrlMedia* _tmp93_;
			LCDPlayer* _tmp111_;
			StatePlay* _tmp112_;
			_tmp81_ = self->priv->categories;
			_tmp82_ = gee_abstract_list_get ((GeeAbstractList*) _tmp81_, self->priv->current);
			_tmp83_ = (Category*) _tmp82_;
			_tmp84_ = (*_tmp83_).media;
			_vala_assert (G_TYPE_CHECK_INSTANCE_TYPE (_tmp84_, grl_media_get_type ()), "categories[current].media is Grl.Media");
			_category_free0 (_tmp83_);
			_tmp85_ = self->priv->categories;
			_tmp86_ = gee_abstract_list_get ((GeeAbstractList*) _tmp85_, self->priv->current);
			_tmp87_ = (Category*) _tmp86_;
			_tmp88_ = (*_tmp87_).media;
			_tmp89_ = _g_object_ref0 (_tmp88_);
			_tmp90_ = _tmp89_;
			_category_free0 (_tmp87_);
			media = _tmp90_;
			_tmp91_ = ((State*) self)->player;
			_tmp92_ = _tmp91_->playlist;
			_tmp93_ = media;
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp92_, _tmp93_)) {
				LCDPlayer* _tmp94_;
				InputOutput* _tmp95_;
				GrlMedia* _tmp96_;
				const gchar* _tmp97_;
				gchar* _tmp98_;
				gchar* _tmp99_;
				_tmp94_ = ((State*) self)->player;
				_tmp95_ = _tmp94_->io;
				_tmp96_ = media;
				_tmp97_ = grl_media_get_title (_tmp96_);
				_tmp98_ = g_strconcat (_tmp97_, " already in queue", NULL);
				_tmp99_ = _tmp98_;
				input_output_output (_tmp95_, _tmp99_);
				_g_free0 (_tmp99_);
			} else {
				LCDPlayer* _tmp100_;
				GeeArrayList* _tmp101_;
				GrlMedia* _tmp102_;
				LCDPlayer* _tmp103_;
				InputOutput* _tmp104_;
				GrlMedia* _tmp105_;
				const gchar* _tmp106_;
				gchar* _tmp107_;
				gchar* _tmp108_;
				gchar* _tmp109_;
				gchar* _tmp110_;
				_tmp100_ = ((State*) self)->player;
				_tmp101_ = _tmp100_->playlist;
				_tmp102_ = media;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp101_, G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, grl_media_get_type (), GrlMedia));
				_tmp103_ = ((State*) self)->player;
				_tmp104_ = _tmp103_->io;
				_tmp105_ = media;
				_tmp106_ = grl_media_get_title (_tmp105_);
				_tmp107_ = g_strconcat ("Added '", _tmp106_, NULL);
				_tmp108_ = _tmp107_;
				_tmp109_ = g_strconcat (_tmp108_, "' to queue", NULL);
				_tmp110_ = _tmp109_;
				input_output_output (_tmp104_, _tmp110_);
				_g_free0 (_tmp110_);
				_g_free0 (_tmp108_);
			}
			_tmp111_ = ((State*) self)->player;
			_tmp112_ = state_play_new (_tmp111_);
			result = (State*) _tmp112_;
			_g_object_unref0 (media);
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static inline gpointer
state_choose_category_child_media_list_builder_get_instance_private (StateChooseCategoryChildMediaListBuilder* self)
{
	return G_STRUCT_MEMBER_P (self, StateChooseCategoryChildMediaListBuilder_private_offset);
}

static StateChooseCategoryChildMediaListBuilder*
state_choose_category_child_media_list_builder_construct (GType object_type,
                                                          StateChooseCategory* state)
{
	StateChooseCategoryChildMediaListBuilder* self = NULL;
	StateChooseCategory* _tmp0_;
	g_return_val_if_fail (state != NULL, NULL);
	self = (StateChooseCategoryChildMediaListBuilder*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (state);
	_g_object_unref0 (self->priv->state);
	self->priv->state = _tmp0_;
	return self;
}

static StateChooseCategoryChildMediaListBuilder*
state_choose_category_child_media_list_builder_new (StateChooseCategory* state)
{
	return state_choose_category_child_media_list_builder_construct (STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER, state);
}

static void
state_choose_category_child_media_list_builder_browse_cb (StateChooseCategoryChildMediaListBuilder* self,
                                                          GrlSource* source,
                                                          guint operation_id,
                                                          GrlMedia* media,
                                                          guint remaining,
                                                          GError* _error_)
{
	guint _tmp0_;
	StateChooseCategory* _tmp1_;
	GrlMedia* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_vala_assert (self->priv->count <= ((guint) PAGE_SIZE), "count <= PAGE_SIZE");
	if (NULL != _error_) {
		_g_object_unref0 (media);
		return;
	}
	if (NULL == media) {
		_g_object_unref0 (media);
		return;
	}
	_tmp0_ = self->priv->count;
	self->priv->count = _tmp0_ + 1;
	_tmp1_ = self->priv->state;
	_tmp2_ = _tmp1_->priv->canary;
	if (NULL != _tmp2_) {
		StateChooseCategory* _tmp3_;
		GeeArrayList* _tmp4_;
		StateChooseCategory* _tmp5_;
		GrlMedia* _tmp6_;
		StateChooseCategory* _tmp7_;
		_tmp3_ = self->priv->state;
		_tmp4_ = _tmp3_->priv->media;
		_tmp5_ = self->priv->state;
		_tmp6_ = _tmp5_->priv->canary;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp6_);
		_tmp7_ = self->priv->state;
		_g_object_unref0 (_tmp7_->priv->canary);
		_tmp7_->priv->canary = NULL;
	}
	if (self->priv->count == ((guint) PAGE_SIZE)) {
		StateChooseCategory* _tmp8_;
		GrlMedia* _tmp9_;
		_tmp8_ = self->priv->state;
		_tmp9_ = _g_object_ref0 (media);
		_g_object_unref0 (_tmp8_->priv->canary);
		_tmp8_->priv->canary = _tmp9_;
	} else {
		StateChooseCategory* _tmp10_;
		GeeArrayList* _tmp11_;
		_tmp10_ = self->priv->state;
		_tmp11_ = _tmp10_->priv->media;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, media);
	}
	if (((guint) 0) == remaining) {
		StateChooseCategory* _tmp12_;
		GeeArrayList* _tmp13_;
		StateChooseCategory* _tmp14_;
		_tmp12_ = self->priv->state;
		_tmp13_ = _tmp12_->priv->media;
		gee_list_sort ((GeeList*) _tmp13_, _media_compare_gcompare_data_func, NULL, NULL);
		_tmp14_ = self->priv->state;
		state_choose_category_connected_cb (_tmp14_, source);
	}
	_g_object_unref0 (media);
}

static void
state_choose_category_value_child_media_list_builder_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
state_choose_category_value_child_media_list_builder_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		state_choose_category_child_media_list_builder_unref (value->data[0].v_pointer);
	}
}

static void
state_choose_category_value_child_media_list_builder_copy_value (const GValue* src_value,
                                                                 GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = state_choose_category_child_media_list_builder_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
state_choose_category_value_child_media_list_builder_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
state_choose_category_value_child_media_list_builder_collect_value (GValue* value,
                                                                    guint n_collect_values,
                                                                    GTypeCValue* collect_values,
                                                                    guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		StateChooseCategoryChildMediaListBuilder * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = state_choose_category_child_media_list_builder_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
state_choose_category_value_child_media_list_builder_lcopy_value (const GValue* value,
                                                                  guint n_collect_values,
                                                                  GTypeCValue* collect_values,
                                                                  guint collect_flags)
{
	StateChooseCategoryChildMediaListBuilder ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = state_choose_category_child_media_list_builder_ref (value->data[0].v_pointer);
	}
	return NULL;
}

static GParamSpec*
state_choose_category_param_spec_child_media_list_builder (const gchar* name,
                                                           const gchar* nick,
                                                           const gchar* blurb,
                                                           GType object_type,
                                                           GParamFlags flags)
{
	StateChooseCategoryParamSpecChildMediaListBuilder* spec;
	g_return_val_if_fail (g_type_is_a (object_type, STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

static gpointer
state_choose_category_value_get_child_media_list_builder (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER), NULL);
	return value->data[0].v_pointer;
}

static void
state_choose_category_value_set_child_media_list_builder (GValue* value,
                                                          gpointer v_object)
{
	StateChooseCategoryChildMediaListBuilder * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		state_choose_category_child_media_list_builder_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		state_choose_category_child_media_list_builder_unref (old);
	}
}

static void
state_choose_category_value_take_child_media_list_builder (GValue* value,
                                                           gpointer v_object)
{
	StateChooseCategoryChildMediaListBuilder * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		state_choose_category_child_media_list_builder_unref (old);
	}
}

static void
state_choose_category_child_media_list_builder_class_init (StateChooseCategoryChildMediaListBuilderClass * klass,
                                                           gpointer klass_data)
{
	state_choose_category_child_media_list_builder_parent_class = g_type_class_peek_parent (klass);
	((StateChooseCategoryChildMediaListBuilderClass *) klass)->finalize = state_choose_category_child_media_list_builder_finalize;
	g_type_class_adjust_private_offset (klass, &StateChooseCategoryChildMediaListBuilder_private_offset);
}

static void
state_choose_category_child_media_list_builder_instance_init (StateChooseCategoryChildMediaListBuilder * self,
                                                              gpointer klass)
{
	self->priv = state_choose_category_child_media_list_builder_get_instance_private (self);
	self->priv->count = (guint) 0;
	self->ref_count = 1;
}

static void
state_choose_category_child_media_list_builder_finalize (StateChooseCategoryChildMediaListBuilder * obj)
{
	StateChooseCategoryChildMediaListBuilder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STATE_CHOOSE_CATEGORY_TYPE_CHILD_MEDIA_LIST_BUILDER, StateChooseCategoryChildMediaListBuilder);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->state);
}

static GType
state_choose_category_child_media_list_builder_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { state_choose_category_value_child_media_list_builder_init, state_choose_category_value_child_media_list_builder_free_value, state_choose_category_value_child_media_list_builder_copy_value, state_choose_category_value_child_media_list_builder_peek_pointer, "p", state_choose_category_value_child_media_list_builder_collect_value, "p", state_choose_category_value_child_media_list_builder_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (StateChooseCategoryChildMediaListBuilderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) state_choose_category_child_media_list_builder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StateChooseCategoryChildMediaListBuilder), 0, (GInstanceInitFunc) state_choose_category_child_media_list_builder_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType state_choose_category_child_media_list_builder_type_id;
	state_choose_category_child_media_list_builder_type_id = g_type_register_fundamental (g_type_fundamental_next (), "StateChooseCategoryChildMediaListBuilder", &g_define_type_info, &g_define_type_fundamental_info, 0);
	StateChooseCategoryChildMediaListBuilder_private_offset = g_type_add_instance_private (state_choose_category_child_media_list_builder_type_id, sizeof (StateChooseCategoryChildMediaListBuilderPrivate));
	return state_choose_category_child_media_list_builder_type_id;
}

static GType
state_choose_category_child_media_list_builder_get_type (void)
{
	static volatile gsize state_choose_category_child_media_list_builder_type_id__once = 0;
	if (g_once_init_enter (&state_choose_category_child_media_list_builder_type_id__once)) {
		GType state_choose_category_child_media_list_builder_type_id;
		state_choose_category_child_media_list_builder_type_id = state_choose_category_child_media_list_builder_get_type_once ();
		g_once_init_leave (&state_choose_category_child_media_list_builder_type_id__once, state_choose_category_child_media_list_builder_type_id);
	}
	return state_choose_category_child_media_list_builder_type_id__once;
}

static gpointer
state_choose_category_child_media_list_builder_ref (gpointer instance)
{
	StateChooseCategoryChildMediaListBuilder * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

static void
state_choose_category_child_media_list_builder_unref (gpointer instance)
{
	StateChooseCategoryChildMediaListBuilder * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		STATE_CHOOSE_CATEGORY_CHILD_MEDIA_LIST_BUILDER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
state_choose_category_class_init (StateChooseCategoryClass * klass,
                                  gpointer klass_data)
{
	state_choose_category_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &StateChooseCategory_private_offset);
	((StateClass *) klass)->print_selected = (void (*) (State*)) state_choose_category_real_print_selected;
	((StateClass *) klass)->seekback = (void (*) (State*)) state_choose_category_real_seekback;
	((StateClass *) klass)->seekforward = (void (*) (State*)) state_choose_category_real_seekforward;
	((StateClass *) klass)->next = (void (*) (State*)) state_choose_category_real_next;
	((StateClass *) klass)->previous = (void (*) (State*)) state_choose_category_real_previous;
	((StateClass *) klass)->transition = (State* (*) (State*)) state_choose_category_real_transition;
	G_OBJECT_CLASS (klass)->finalize = state_choose_category_finalize;
}

static void
state_choose_category_instance_init (StateChooseCategory * self,
                                     gpointer klass)
{
	GeeArrayList* _tmp0_;
	self->priv = state_choose_category_get_instance_private (self);
	self->priv->page = 0;
	self->priv->current = 0;
	self->priv->canary = NULL;
	_tmp0_ = gee_array_list_new (grl_media_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->media = _tmp0_;
}

static void
state_choose_category_finalize (GObject * obj)
{
	StateChooseCategory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATE_CHOOSE_CATEGORY, StateChooseCategory);
	_g_object_unref0 (self->priv->parent_selection);
	_g_main_loop_unref0 (self->priv->loop);
	_g_object_unref0 (self->priv->source);
	_g_object_unref0 (self->priv->categories);
	_g_object_unref0 (self->priv->canary);
	_g_object_unref0 (self->priv->media);
	_state_choose_category_child_media_list_builder_unref0 (self->priv->child_media_list_builder);
	G_OBJECT_CLASS (state_choose_category_parent_class)->finalize (obj);
}

static GType
state_choose_category_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StateChooseCategoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) state_choose_category_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StateChooseCategory), 0, (GInstanceInitFunc) state_choose_category_instance_init, NULL };
	GType state_choose_category_type_id;
	state_choose_category_type_id = g_type_register_static (TYPE_STATE, "StateChooseCategory", &g_define_type_info, 0);
	StateChooseCategory_private_offset = g_type_add_instance_private (state_choose_category_type_id, sizeof (StateChooseCategoryPrivate));
	return state_choose_category_type_id;
}

GType
state_choose_category_get_type (void)
{
	static volatile gsize state_choose_category_type_id__once = 0;
	if (g_once_init_enter (&state_choose_category_type_id__once)) {
		GType state_choose_category_type_id;
		state_choose_category_type_id = state_choose_category_get_type_once ();
		g_once_init_leave (&state_choose_category_type_id__once, state_choose_category_type_id);
	}
	return state_choose_category_type_id__once;
}

