/* transitions.c generated by valac 0.56.17, the Vala compiler
 * generated from transitions.vala, do not modify */

/*   FILE: transitions.vala -- Code to handle state transitions in response to inputs
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 27 November 2013
 *
 * Copyright (c) 2013 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib-object.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_TRANSITIONS (transitions_get_type ())
#define TRANSITIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSITIONS, Transitions))
#define TRANSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSITIONS, TransitionsClass))
#define IS_TRANSITIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSITIONS))
#define IS_TRANSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSITIONS))
#define TRANSITIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSITIONS, TransitionsClass))

typedef struct _Transitions Transitions;
typedef struct _TransitionsClass TransitionsClass;
typedef struct _TransitionsPrivate TransitionsPrivate;

#define TYPE_STACK (stack_get_type ())
#define STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STACK, Stack))
#define STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STACK, StackClass))
#define IS_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STACK))
#define IS_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STACK))
#define STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STACK, StackClass))

typedef struct _Stack Stack;
typedef struct _StackClass StackClass;

#define TYPE_STATE (state_get_type ())
#define STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE, State))
#define STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE, StateClass))
#define IS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE))
#define IS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE))
#define STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE, StateClass))

typedef struct _State State;
typedef struct _StateClass StateClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_INPUT_OUTPUT (input_output_get_type ())
#define INPUT_OUTPUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INPUT_OUTPUT, InputOutput))
#define INPUT_OUTPUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INPUT_OUTPUT, InputOutputClass))
#define IS_INPUT_OUTPUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INPUT_OUTPUT))
#define IS_INPUT_OUTPUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INPUT_OUTPUT))
#define INPUT_OUTPUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INPUT_OUTPUT, InputOutputClass))

typedef struct _InputOutput InputOutput;
typedef struct _InputOutputClass InputOutputClass;
typedef struct _ParamSpecTransitions ParamSpecTransitions;

struct _Transitions {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TransitionsPrivate * priv;
};

struct _TransitionsClass {
	GTypeClass parent_class;
	void (*finalize) (Transitions *self);
};

struct _TransitionsPrivate {
	Stack* stateStack;
};

struct _ParamSpecTransitions {
	GParamSpec parent_instance;
};

static gint Transitions_private_offset;
static gpointer transitions_parent_class = NULL;

VALA_EXTERN gpointer transitions_ref (gpointer instance);
VALA_EXTERN void transitions_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_transitions (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_transitions (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_transitions (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_transitions (const GValue* value);
VALA_EXTERN GType transitions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Transitions, transitions_unref)
VALA_EXTERN GType stack_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Stack, g_object_unref)
VALA_EXTERN GType state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (State, g_object_unref)
VALA_EXTERN GType input_output_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (InputOutput, g_object_unref)
VALA_EXTERN Transitions* transitions_new (InputOutput* io,
                              Stack* stateStack);
VALA_EXTERN Transitions* transitions_construct (GType object_type,
                                    InputOutput* io,
                                    Stack* stateStack);
static void __lambda5_ (Transitions* self);
static void transitions_do_stop (Transitions* self);
static void ___lambda5__input_output_stop (InputOutput* _sender,
                                    gpointer self);
static void __lambda6_ (Transitions* self);
static void transitions_do_seekback (Transitions* self);
static void ___lambda6__input_output_seekback (InputOutput* _sender,
                                        gpointer self);
static void __lambda7_ (Transitions* self);
static void transitions_do_pauseplay (Transitions* self);
static void ___lambda7__input_output_pauseplay (InputOutput* _sender,
                                         gpointer self);
static void __lambda8_ (Transitions* self);
static void transitions_do_seekforward (Transitions* self);
static void ___lambda8__input_output_seekforward (InputOutput* _sender,
                                           gpointer self);
static void __lambda9_ (Transitions* self);
static void transitions_do_escape (Transitions* self);
static void ___lambda9__input_output_escape (InputOutput* _sender,
                                      gpointer self);
static void __lambda10_ (Transitions* self);
static void transitions_do_left (Transitions* self);
static void ___lambda10__input_output_left (InputOutput* _sender,
                                     gpointer self);
static void __lambda11_ (Transitions* self);
static void transitions_do_right (Transitions* self);
static void ___lambda11__input_output_right (InputOutput* _sender,
                                      gpointer self);
static void __lambda12_ (Transitions* self);
static void transitions_do_select (Transitions* self);
static void ___lambda12__input_output_select (InputOutput* _sender,
                                       gpointer self);
VALA_EXTERN gpointer stack_peek (Stack* self);
VALA_EXTERN void state_stop (State* self);
VALA_EXTERN void state_seekback (State* self);
VALA_EXTERN void state_pauseplay (State* self);
VALA_EXTERN void state_seekforward (State* self);
VALA_EXTERN gsize stack_size (Stack* self);
VALA_EXTERN gpointer stack_pop (Stack* self);
VALA_EXTERN void state_print_selected (State* self);
VALA_EXTERN void state_previous (State* self);
VALA_EXTERN void state_next (State* self);
VALA_EXTERN State* state_transition (State* self);
VALA_EXTERN void stack_push (Stack* self,
                 gconstpointer item);
static void transitions_finalize (Transitions * obj);
static GType transitions_get_type_once (void);

static inline gpointer
transitions_get_instance_private (Transitions* self)
{
	return G_STRUCT_MEMBER_P (self, Transitions_private_offset);
}

static void
__lambda5_ (Transitions* self)
{
	transitions_do_stop (self);
}

static void
___lambda5__input_output_stop (InputOutput* _sender,
                               gpointer self)
{
	__lambda5_ ((Transitions*) self);
}

static void
__lambda6_ (Transitions* self)
{
	transitions_do_seekback (self);
}

static void
___lambda6__input_output_seekback (InputOutput* _sender,
                                   gpointer self)
{
	__lambda6_ ((Transitions*) self);
}

static void
__lambda7_ (Transitions* self)
{
	transitions_do_pauseplay (self);
}

static void
___lambda7__input_output_pauseplay (InputOutput* _sender,
                                    gpointer self)
{
	__lambda7_ ((Transitions*) self);
}

static void
__lambda8_ (Transitions* self)
{
	transitions_do_seekforward (self);
}

static void
___lambda8__input_output_seekforward (InputOutput* _sender,
                                      gpointer self)
{
	__lambda8_ ((Transitions*) self);
}

static void
__lambda9_ (Transitions* self)
{
	transitions_do_escape (self);
}

static void
___lambda9__input_output_escape (InputOutput* _sender,
                                 gpointer self)
{
	__lambda9_ ((Transitions*) self);
}

static void
__lambda10_ (Transitions* self)
{
	transitions_do_left (self);
}

static void
___lambda10__input_output_left (InputOutput* _sender,
                                gpointer self)
{
	__lambda10_ ((Transitions*) self);
}

static void
__lambda11_ (Transitions* self)
{
	transitions_do_right (self);
}

static void
___lambda11__input_output_right (InputOutput* _sender,
                                 gpointer self)
{
	__lambda11_ ((Transitions*) self);
}

static void
__lambda12_ (Transitions* self)
{
	transitions_do_select (self);
}

static void
___lambda12__input_output_select (InputOutput* _sender,
                                  gpointer self)
{
	__lambda12_ ((Transitions*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

Transitions*
transitions_construct (GType object_type,
                       InputOutput* io,
                       Stack* stateStack)
{
	Transitions* self = NULL;
	Stack* _tmp0_;
	g_return_val_if_fail (io != NULL, NULL);
	g_return_val_if_fail (stateStack != NULL, NULL);
	self = (Transitions*) g_type_create_instance (object_type);
	g_signal_connect (io, "stop", (GCallback) ___lambda5__input_output_stop, self);
	g_signal_connect (io, "seekback", (GCallback) ___lambda6__input_output_seekback, self);
	g_signal_connect (io, "pauseplay", (GCallback) ___lambda7__input_output_pauseplay, self);
	g_signal_connect (io, "seekforward", (GCallback) ___lambda8__input_output_seekforward, self);
	g_signal_connect (io, "escape", (GCallback) ___lambda9__input_output_escape, self);
	g_signal_connect (io, "left", (GCallback) ___lambda10__input_output_left, self);
	g_signal_connect (io, "right", (GCallback) ___lambda11__input_output_right, self);
	g_signal_connect (io, "select", (GCallback) ___lambda12__input_output_select, self);
	_tmp0_ = _g_object_ref0 (stateStack);
	_g_object_unref0 (self->priv->stateStack);
	self->priv->stateStack = _tmp0_;
	return self;
}

Transitions*
transitions_new (InputOutput* io,
                 Stack* stateStack)
{
	return transitions_construct (TYPE_TRANSITIONS, io, stateStack);
}

static void
transitions_do_stop (Transitions* self)
{
	Stack* _tmp0_;
	gpointer _tmp1_;
	State* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stateStack;
	_tmp1_ = stack_peek (_tmp0_);
	_tmp2_ = (State*) _tmp1_;
	state_stop (_tmp2_);
	_g_object_unref0 (_tmp2_);
}

static void
transitions_do_seekback (Transitions* self)
{
	Stack* _tmp0_;
	gpointer _tmp1_;
	State* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stateStack;
	_tmp1_ = stack_peek (_tmp0_);
	_tmp2_ = (State*) _tmp1_;
	state_seekback (_tmp2_);
	_g_object_unref0 (_tmp2_);
}

static void
transitions_do_pauseplay (Transitions* self)
{
	Stack* _tmp0_;
	gpointer _tmp1_;
	State* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stateStack;
	_tmp1_ = stack_peek (_tmp0_);
	_tmp2_ = (State*) _tmp1_;
	state_pauseplay (_tmp2_);
	_g_object_unref0 (_tmp2_);
}

static void
transitions_do_seekforward (Transitions* self)
{
	Stack* _tmp0_;
	gpointer _tmp1_;
	State* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stateStack;
	_tmp1_ = stack_peek (_tmp0_);
	_tmp2_ = (State*) _tmp1_;
	state_seekforward (_tmp2_);
	_g_object_unref0 (_tmp2_);
}

static void
transitions_do_escape (Transitions* self)
{
	Stack* _tmp0_;
	Stack* _tmp4_;
	gpointer _tmp5_;
	State* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stateStack;
	if (stack_size (_tmp0_) > ((gsize) 1)) {
		Stack* _tmp1_;
		gpointer _tmp2_;
		State* _tmp3_;
		_tmp1_ = self->priv->stateStack;
		_tmp2_ = stack_pop (_tmp1_);
		_tmp3_ = (State*) _tmp2_;
		_g_object_unref0 (_tmp3_);
	}
	_tmp4_ = self->priv->stateStack;
	_tmp5_ = stack_peek (_tmp4_);
	_tmp6_ = (State*) _tmp5_;
	state_print_selected (_tmp6_);
	_g_object_unref0 (_tmp6_);
}

static void
transitions_do_left (Transitions* self)
{
	Stack* _tmp0_;
	gpointer _tmp1_;
	State* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stateStack;
	_tmp1_ = stack_peek (_tmp0_);
	_tmp2_ = (State*) _tmp1_;
	state_previous (_tmp2_);
	_g_object_unref0 (_tmp2_);
}

static void
transitions_do_right (Transitions* self)
{
	Stack* _tmp0_;
	gpointer _tmp1_;
	State* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stateStack;
	_tmp1_ = stack_peek (_tmp0_);
	_tmp2_ = (State*) _tmp1_;
	state_next (_tmp2_);
	_g_object_unref0 (_tmp2_);
}

static void
transitions_do_select (Transitions* self)
{
	State* next = NULL;
	Stack* _tmp0_;
	gpointer _tmp1_;
	State* _tmp2_;
	State* _tmp3_;
	State* _tmp4_;
	Stack* _tmp5_;
	gpointer _tmp6_;
	State* _tmp7_;
	State* _tmp8_;
	gboolean _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stateStack;
	_tmp1_ = stack_peek (_tmp0_);
	_tmp2_ = (State*) _tmp1_;
	_tmp3_ = state_transition (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	next = _tmp4_;
	_tmp5_ = self->priv->stateStack;
	_tmp6_ = stack_peek (_tmp5_);
	_tmp7_ = (State*) _tmp6_;
	_tmp8_ = next;
	_tmp9_ = _tmp7_ != _tmp8_;
	_g_object_unref0 (_tmp7_);
	if (_tmp9_) {
		Stack* _tmp10_;
		State* _tmp11_;
		_tmp10_ = self->priv->stateStack;
		_tmp11_ = next;
		stack_push (_tmp10_, _tmp11_);
	}
	_g_object_unref0 (next);
}

static void
value_transitions_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_transitions_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		transitions_unref (value->data[0].v_pointer);
	}
}

static void
value_transitions_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = transitions_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_transitions_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_transitions_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		Transitions * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = transitions_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_transitions_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	Transitions ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = transitions_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_transitions (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecTransitions* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TRANSITIONS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_transitions (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSITIONS), NULL);
	return value->data[0].v_pointer;
}

void
value_set_transitions (GValue* value,
                       gpointer v_object)
{
	Transitions * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSITIONS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TRANSITIONS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		transitions_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		transitions_unref (old);
	}
}

void
value_take_transitions (GValue* value,
                        gpointer v_object)
{
	Transitions * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSITIONS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TRANSITIONS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		transitions_unref (old);
	}
}

static void
transitions_class_init (TransitionsClass * klass,
                        gpointer klass_data)
{
	transitions_parent_class = g_type_class_peek_parent (klass);
	((TransitionsClass *) klass)->finalize = transitions_finalize;
	g_type_class_adjust_private_offset (klass, &Transitions_private_offset);
}

static void
transitions_instance_init (Transitions * self,
                           gpointer klass)
{
	self->priv = transitions_get_instance_private (self);
	self->ref_count = 1;
}

static void
transitions_finalize (Transitions * obj)
{
	Transitions * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TRANSITIONS, Transitions);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->stateStack);
}

static GType
transitions_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_transitions_init, value_transitions_free_value, value_transitions_copy_value, value_transitions_peek_pointer, "p", value_transitions_collect_value, "p", value_transitions_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TransitionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) transitions_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Transitions), 0, (GInstanceInitFunc) transitions_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType transitions_type_id;
	transitions_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Transitions", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Transitions_private_offset = g_type_add_instance_private (transitions_type_id, sizeof (TransitionsPrivate));
	return transitions_type_id;
}

GType
transitions_get_type (void)
{
	static volatile gsize transitions_type_id__once = 0;
	if (g_once_init_enter (&transitions_type_id__once)) {
		GType transitions_type_id;
		transitions_type_id = transitions_get_type_once ();
		g_once_init_leave (&transitions_type_id__once, transitions_type_id);
	}
	return transitions_type_id__once;
}

gpointer
transitions_ref (gpointer instance)
{
	Transitions * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
transitions_unref (gpointer instance)
{
	Transitions * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TRANSITIONS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

